with Ada.Text_IO; use Ada.Text_IO;
procedure primos is

package enter_io is new Ada.Text_IO.Integer_IO(integer);
use enter_io;

type tabla is array(0..50) of integer; 
-- Com que guardarem el primers entre 1 y 100 amb 50 posicions 
-- tenim mes que suficient (la meitat de num. seran multiples de 2).

primos: tabla;  -- En aquesta taula guardarem el numeros primers que trobem.
i,j: integer;  -- Variables utilitzades com index.

begin

 primos(0):=1;primos(1):=2; -- Guardem els 2 primers nombres primers
 i:=1; -- Index de la ultima posicio a on em escrit

--
-- No cal inicialitzar la taula pq li asignarem valors mes tard
-- i al final nomes mostrarem aquelles posicions a on hem guardat un valor
--
-- for i in 2..99 loop
--  primos(i):=0;
-- end loop;
--

 for num in 3..100 loop  -- Buscarem la resta de numeros primers que ens falten
  j:=1;  -- Posicio de l'index auxiliar, farem una cerca des de la posicio 1
	 -- fins a l'ultima pos. a on esta l'ultim primer trobat (mes optimitzat
	 -- que si la fessim al contrari).
	 -- La primera posicio (0) la saltem pq cualsevol numero es divisible per 1
  while (num mod primos(j) /= 0) and (j<i) loop
   j:=j+1;
  end loop;
  if (num mod primos(j) /= 0)  then 
    -- Si em sortit del while pq no era divisible llavors el numero es primer.
    -- El guardem a la taula i avancem l'index principal.
   i:=i+1;
   primos(i):=num;
  end if;
 end loop;

 -- Visualitzem tots el numeros primers que em trobat.
 put("Numeros primers entre 1 i 100:");new_line;
 for j in 0..i loop
  put(primos(j)); new_line;
 end loop;

end primos;
